@ECHO OFF
CLS
SETLOCAL
::   ࠭ १ࢭ  - ᫨   ⥪  ᢮
:: -㬮砭 ⥪ 
SET "BACKUP_DIR=%~dp0"
:: ﭭ   娢 -  㭨쭮 䨪樨 娢
SET "SOURCE_NAME=MY_BACKUP_1"

::   ᯮ 䠩  ᯨ᪮  १ࢭ ஢
::      ᨬ "\"     
SET "BACKUP_LIST=%~dp0listbackup.txt"

:: ஢ ᯨ᪠ - 㯭 ਠ: UTF-8, WIN, DOS
SET "LIST_CHARSET=DOS"

:: : DAY, WEEK, MONTH, YEAR
::  ᫮
::1 - ᥭ
::2 - 쭨
::3 - ୨
::4 - ।
::5 - ⢥
::6 - ⭨
::7 - 㡡
::    ண ⠥ 
SET "WEEK_DAY_BACKUP=1"

::  ᫥ ᫠  ⠥ 
::  ᫥ ᫠  ⠥ 
:: ⢮ ࠭ 客   ⨯
SET "REZERV_DAY=6"
SET "REZERV_WEEK=5"
SET "REZERV_MONTH=11"
SET "REZERV_YEAR=50"
:: :  娢 㤥  :
:: %SOURCE_NAME%____%TYPE_BACKUP%.7z

ECHO.
ECHO %DATE% - %TIME:~0,5%  ࢭ ஢:
ECHO              ⥫ ਯ: "%~0"
ECHO              ᯨ᮪: "%BACKUP_LIST%"

CALL :BACKUP_PATHS
CALL :SYS_TYPE
CALL :DATE_SET
CALL :ARC
CALL :REZERV_TRIM

ENDLOCAL
GOTO :EOF

:SYS_TYPE
:: । ࠧ來 ⥬  ᯮ짮 㦭 ᨨ 娢
ECHO "%PROCESSOR_ARCHITECTURE%""%PROCESSOR_ARCHITEW6432%"|1>NUL 2>NUL FIND /I "AMD64"&&SET "ARC_DIR=%~dp0X64"||SET "ARC_DIR=%~dp0X32"
:: 뢠 ᫥ ᨬ "\"   娢
SET "LAST_CHAR=%ARC_DIR:~-1%"
IF "%LAST_CHAR%"=="\" SET "ARC_DIR=%ARC_DIR:~0,-1%"
IF NOT EXIST "%ARC_DIR%\7z.exe" (
ECHO  㦥 娢   "%ARC_DIR%"!
ECHO  ᮮ⢥  7z.exe   .\X64  .\X86  १ ਯ!
CALL :ERROR 1
)
GOTO :EOF

:BACKUP_PATHS
:: 뢠 ᫥ ᨬ "\"   
SET "LAST_CHAR=%BACKUP_DIR:~-1%"
IF "%LAST_CHAR%"=="\" SET "BACKUP_DIR=%BACKUP_DIR:~0,-1%"
::  楫   १ࢭ ஢  ஢મ ⢮
IF NOT EXIST "%BACKUP_DIR%" MD "%BACKUP_DIR%"
IF NOT EXIST "%BACKUP_DIR%" (
ECHO    ᮧ  㯭!
CALL :ERROR 2
)
ECHO              ࢭ  㤥 ᮧ   %BACKUP_DIR%
GOTO :EOF

:DATE_SET
:: । ࠬ஢ ⥪饩   ⨯ 
ECHO wscript.ECHO YEAR(DATE)^&"_"^&RIGHT(0^&MONTH(DATE),2)^&"_"^&RIGHT(0^&DAY(DATE),2)^&"_"^& DAY(DATESERIAL(YEAR(DATE),MONTH(DATE)+1,1-1))^&"_"^&WEEKDAY(DATE)^&"_"^&RIGHT(0^&hour(TIME),2)^&"_"^&RIGHT(0^&minute(TIME),2) 1>"%TEMP%\tmp.vbs"
FOR /F "TOKENS=1,2,3,4,5,6,7 DELIMS=_" %%a IN ('cscript "%TEMP%\tmp.vbs" //Nologo') DO SET "TEK_YEAR=%%a"&SET "TEK_MONTH=%%b"&SET "TEK_DAY=%%c"&SET "LAST_DAY=%%d"&SET "TEK_WEEK=%%e"&SET "TEK_HOUR=%%f"&SET "TEK_MINUTE=%%g"
IF EXIST "%TEMP%\tmp.vbs" DEL "%TEMP%\tmp.vbs"
SET "TYPE_BACKUP=DAY"
IF "%WEEK_DAY_BACKUP%"=="%TEK_WEEK%" SET "TYPE_BACKUP=WEEK"
IF "%TEK_DAY%"=="%LAST_DAY%" SET "TYPE_BACKUP=MONTH"
IF "%TEK_MONTH%"=="12" (IF "%TEK_DAY%"=="%LAST_DAY%" (SET "TYPE_BACKUP=YEAR"))
CALL SET "REZERV_NUM=%%REZERV_%TYPE_BACKUP%%%"
SET "ARC_NAME=%SOURCE_NAME%_%TEK_YEAR%_%TEK_MONTH%_%TEK_DAY%~%TYPE_BACKUP%"
IF EXIST "%BACKUP_DIR%\%ARC_NAME%.7z" (
ECHO ࢭ     㦥 ᮧ!
ECHO   २    ਯ ୮!
CALL :ERROR 3
)
GOTO :EOF

:ARC
IF EXIST "%ARC_DIR%\7z.exe" (
1>nul "%ARC_DIR%\7z.exe" a -t7z "%BACKUP_DIR%\%ARC_NAME%.7z" @"%BACKUP_LIST%" -ms -mmt -mx7 -bd -scs%LIST_CHARSET% -ssw 

ECHO              客  ᮧ...
)
GOTO :EOF

:REZERV_TRIM
ECHO               ॢ訥 १ࢭ :
FOR /F "SKIP=%REZERV_NUM% USEBACKQ TOKENS=1 DELIMS=" %%a IN (`DIR /O:-N /B "%BACKUP_DIR%\%SOURCE_NAME%_20??_??_??~%TYPE_BACKUP%.7z"`) DO (
DEL /Q /F "%BACKUP_DIR%\%%a"
ECHO              "%BACKUP_DIR%\%%a"
)
GOTO :EOF

:ERROR
ECHO ந諮 ᠤ ࠧ㬥 - १ࢭ   ᮧ ...
ENDLOCAL
EXIT %~1
